<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JPSOAP_OrderedTypedPrice StructType
 * @subpackage Structs
 */
class JPSOAP_OrderedTypedPrice extends JPSOAP_OrderedPrice
{
    /**
     * The Type
     * Meta information extracted from the WSDL
     * - use: required
     * @var string
     */
    public $Type;
    /**
     * Constructor method for JPSOAP_OrderedTypedPrice
     * @uses JPSOAP_OrderedTypedPrice::setType()
     * @param string $type
     */
    public function __construct($type = null)
    {
        $this
            ->setType($type);
    }
    /**
     * Get Type value
     * @return string
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @uses \EnumType\JPSOAP_PriceTypes::valueIsValid()
     * @uses \EnumType\JPSOAP_PriceTypes::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \StructType\JPSOAP_OrderedTypedPrice
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\JPSOAP_PriceTypes::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\JPSOAP_PriceTypes', is_array($type) ? implode(', ', $type) : var_export($type, true), implode(', ', \EnumType\JPSOAP_PriceTypes::getValidValues())), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
}
